unit frm_cis;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Menus,
  Vcl.ImgList, System.Actions, Vcl.ActnList, Vcl.ExtCtrls,
  System.UITypes,

  Vcl.Grids, Vcl.DBGrids,
  strutils,
  shellapi,

  jc32_INI,
  jc32_file,

  Vcl.Mask, JvExMask, JvToolEdit, JvComponentBase, JvDragDrop,
  JvExStdCtrls, JvTextListBox, Vcl.CheckLst, JvExCheckLst, JvCheckListBox,
  Vcl.Buttons,

  System.AnsiStrings, Vcl.Samples.Gauges, JvExControls, JvLED, Vcl.ComCtrls,
  Vcl.Imaging.pngimage, JvGIF

    ;

type
  TForm_CIS = class(TForm)
    JvDragDrop1: TJvDragDrop;
    MainMenu1: TMainMenu;
    Fihcier1: TMenuItem;
    Quitter1: TMenuItem;
    ActionList1: TActionList;
    INI_GET: TAction;
    INI_SAVE: TAction;
    Gauge1: TGauge;
    JvCheckListBox1: TJvCheckListBox;
    ListBox1: TListBox;
    N1: TMenuItem;
    mnu_DOWNLOAD: TMenuItem;
    StatusBar1: TStatusBar;
    panel_edit: TPanel;
    Edit_CIP: TLabeledEdit;
    Edit_NOM: TLabeledEdit;
    EDIT_VOIE: TLabeledEdit;
    EDIT_commecialise: TLabeledEdit;
    JvLED_COMM: TJvLED;
    edit_AUTORISATION: TLabeledEdit;
    edit_PROCEDURE: TLabeledEdit;
    edit_FORME: TLabeledEdit;
    edit_NUM: TLabeledEdit;
    JvLED_AUT: TJvLED;
    panel_btn: TPanel;
    btn_ANSM: TBitBtn;
    Panel2: TPanel;
    img_NO: TImage;
    img_YES: TImage;
    Panel3: TPanel;
    Image1: TImage;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    btn_SEARCH: TBitBtn;
    btn_close: TBitBtn;
    btn_VIDAL: TBitBtn;
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint; Value: TStrings);
    procedure FormCreate(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure INI_GETExecute(Sender: TObject);
    procedure INI_SAVEExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_SEARCHClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure mnu_DOWNLOADClick(Sender: TObject);
    procedure JvCheckListBox1Click(Sender: TObject);
    procedure Edit_CIP_SHELLURL(Sender: TObject);
    procedure EDIT_commecialiseChange(Sender: TObject);
    procedure edit_AUTORISATIONChange(Sender: TObject);
    procedure BTN_NoticeClick(Sender: TObject);
    procedure Edit_CIPChange(Sender: TObject);
    procedure btn_ANSMClick(Sender: TObject);
    procedure btn_RCPClick(Sender: TObject);
    procedure btn_VIDALClick(Sender: TObject);
    procedure FormShow(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form_CIS: TForm_CIS;

  _CIS_TXT: string;

implementation

{$R *.dfm}

procedure TForm_CIS.btn_ANSMClick(Sender: TObject);
begin
  ShellFMT('http://agence-prd.ansm.sante.fr/php/ecodex/extrait.php?specid=%s',
    trim(Edit_CIP.Text))
end;

procedure TForm_CIS.BTN_NoticeClick(Sender: TObject);
begin
  ShellFMT('http://agence-prd.ansm.sante.fr/php/ecodex/frames.php?specid=%s&typedoc=N',
    trim(Edit_CIP.Text))
end;

procedure TForm_CIS.btn_RCPClick(Sender: TObject);
begin
  ShellFMT('http://agence-prd.ansm.sante.fr/php/ecodex/frames.php?specid=%s&typedoc=R',
    trim(Edit_CIP.Text))
end;

procedure TForm_CIS.btn_SEARCHClick(Sender: TObject);
var
  i, j: integer;
  Ligne: String;
begin

  if ListBox1.Items.Count = 0 then
    if messagedlg('BASE MEDICAMENTEUSE MANQUANTE !' + ^m + ^j + ^m + ^j +
      'Cliquer sur "Ressayer" pour tlcharger le fichier CIS' + ^m + ^j + ^m +
      ^j + 'Une fois tlcharg' + ^m + ^j +
      'Dposer le fichier "CIS.TXT" sur le  programme pour l''intgrer' + ^m +
      ^j + 'Et relancer la recherche', mtWarning, [mbCancel, mbRetry], 0,
      mbRetry) = mrCancel then
      exit
    else
    begin
      mnu_DOWNLOAD.Click;
      exit;
    end;

  if Edit1.Text = '' then
  begin
    sm('Entrez tout ou partie d''un nom de mdicament sans accent');
    Edit1.SetFocus;
    exit;
  end;

  Gauge1.MinValue := 0;
  Gauge1.MaxValue := ListBox1.Items.Count - 1;
  Gauge1.Show;
  JvCheckListBox1.Items.Clear;
  j := 0;
  StatusBar1.Panels[0].Text := inttostr(ListBox1.Items.Count);
  StatusBar1.Panels[1].Text := '0';
  StatusBar1.Panels[2].Text := '0';

  try

    for i := 0 to ListBox1.Items.Count - 1 do
    Begin
      Gauge1.Progress := i;
      StatusBar1.Panels[1].Text := inttostr(ListBox1.Items.Count - i - 1);
      // Application.ProcessMessages;

      Ligne := ListBox1.Items[i];

      if AnsiContainsText(Ligne, Edit1.Text) then
      Begin
        JvCheckListBox1.Items.Add(replacestr(Ligne, Char(vk_tab), ';'));

        inc(j);
        StatusBar1.Panels[2].Text := inttostr(j);
      End;

    end;

    for i := 0 to JvCheckListBox1.Items.Count - 1 do
    Begin
      Ligne := JvCheckListBox1.Items[i];
      if not AnsiContainsStr(Ligne, 'Non commercialise') then
      Begin
        JvCheckListBox1.Checked[i] := true;
        JvCheckListBox1.Selected[i] := false;
      End
      else
      Begin
        JvCheckListBox1.Checked[i] := false;
        JvCheckListBox1.Selected[i] := true;
      End;
    End;

    if JvCheckListBox1.Items.Count > 0 then
    Begin
      JvCheckListBox1.ItemIndex := 0;
      JvCheckListBox1Click(Sender);
      StatusBar1.Panels[2].Text := format('%d occurence(s) pour "%s"',
        [JvCheckListBox1.Items.Count, Edit1.Text]);
    End;

  finally
    Gauge1.hide;
  end;

end;

procedure TForm_CIS.btn_VIDALClick(Sender: TObject);
begin
  shellexecute(handle, 'OPEN', pchar('http://www.vidal.fr/recherche/index/q:' +
    trim(Edit_NOM.Text) + '/'), nil, nil, SW_SHOWNORMAL);
end;

procedure TForm_CIS.edit_AUTORISATIONChange(Sender: TObject);
begin
  JvLED_AUT.Status := (Pos('Autorisation active', edit_AUTORISATION.Text) > 0);
end;

procedure TForm_CIS.Edit_CIPChange(Sender: TObject);
begin

  btn_ANSM.Enabled := (Edit_CIP.Text <> '');
  btn_vidal.Enabled :=  btn_ANSM.Enabled;

end;

procedure TForm_CIS.Edit_CIP_SHELLURL(Sender: TObject);
begin
  ShellFMT('http://agence-prd.ansm.sante.fr/php/ecodex/extrait.php?specid=%s',
    trim(Edit_CIP.Text))
end;

procedure TForm_CIS.EDIT_commecialiseChange(Sender: TObject);
begin
  JvLED_COMM.Status :=
    not(Pos('Non commercialise', EDIT_commecialise.Text) > 0);

  img_YES.Visible := JvLED_COMM.Status;
  img_NO.Visible := not JvLED_COMM.Status;

end;

procedure TForm_CIS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  INI_SAVE.Execute;
end;

procedure TForm_CIS.FormCreate(Sender: TObject);
var
  FileDate: Tdatetime;
begin

  INI_GET.Execute;

  JvDragDrop1.AcceptDrag := true;

  { Cherche le fichier CIS a cote dee l'excutable }

  { 1 - d'abord dans l'ini }
  _CIS_TXT := GetStr('ANSM', 'CIS.TXT', '');
  if not FileExists(_CIS_TXT) then
    _CIS_TXT := app_path + 'cis.txt';

  if FileExists(_CIS_TXT) then
  Begin
    ListBox1.Items.LoadFromFile(_CIS_TXT);
    FileDate := DateHeureCreationFichier(_CIS_TXT);
    StatusBar1.Panels[3].Text := 'Base de donnes CIS du ' +
      datetostr(FileDate);
  End;

  { Etat es lieux }

  StatusBar1.Panels[0].Text := inttostr(ListBox1.Items.Count);

  if ListBox1.Items.Count <= 0 then
    StatusBar1.Panels[3].Text := 'Base de donnes CIS manquante';

end;

procedure TForm_CIS.FormKeyPress(Sender: TObject; var Key: Char);
var
  i: integer;
begin
  if Key = #27 then
  Begin
    if Edit1.Text = '' then
      close;

    Edit1.Text := '';

    JvCheckListBox1.Items.Clear;

    for i := 0 to ComponentCount - 1 do
      if Components[i] is TLabeledEdit then
        TLabeledEdit(Components[i]).Text := '';

    img_YES.hide;
    img_NO.hide;

    Edit1.SetFocus;
  End;
end;

procedure TForm_CIS.FormShow(Sender: TObject);
begin
  Edit1.SetFocus;
end;

//
procedure TForm_CIS.INI_GETExecute(Sender: TObject);
begin
  GetPosition(self);

end;

procedure TForm_CIS.INI_SAVEExecute(Sender: TObject);
begin
  SavePosition(self);
  saveStr('ANSM', 'CIS.TXT', _CIS_TXT);
end;

procedure TForm_CIS.JvCheckListBox1Click(Sender: TObject);
var
  TAB: tstringlist;
begin

  TAB := tstringlist.Create;

  try

    TAB.Delimiter := ';';
    TAB.QuoteChar := '"';
    TAB.StrictDelimiter := true;
    // ne tient pas  compte des espaces
    TAB.DelimitedText := JvCheckListBox1.Items[JvCheckListBox1.ItemIndex];

    { N = Tabcount = 10 }
    if TAB.Count > 8 then
    BEGIN
      Edit_CIP.Text := TAB[0];
      Edit_NOM.Text := TAB[1];
      edit_FORME.Text := TAB[2];
      // EDIT_PRESENTATION.Text := TAB[3];
      EDIT_VOIE.Text := TAB[3];
      edit_AUTORISATION.Text := TAB[4];
      edit_PROCEDURE.Text := TAB[5];
      EDIT_commecialise.Text := TAB[6];
      edit_NUM.Text := TAB[7];

      caption := Edit_NOM.Text;
    END;

  finally
    TAB.Free;
  end;

end;

procedure TForm_CIS.JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
  Value: TStrings);
begin

  screen.Cursor := crHourGlass;

  if messagedlg('Charger le fichier ?' + ^m + ^j + ^m + ^j + Value[0] + ^m + ^j
    + ^m + ^j +
    'Le Chargement complet de plus de 20.000 mdicaments peut prendre quelques petites secondes, merci de patienter ...',
    mtConfirmation, mbOKCancel, 0) = mrCancel then
    exit;

  ListBox1.Items.Clear;
  _CIS_TXT := Value[0];
  ListBox1.Items.LoadFromFile(_CIS_TXT);

  Application.ProcessMessages;
  screen.Cursor := crDefault;

  // saveStr('ANSM', 'CIS.TXT', Value[0]);

  StatusBar1.Panels[0].Text := inttostr(ListBox1.Items.Count);
  StatusBar1.Panels[3].Text := 'Base de donnes CIS du ' +
    datetostr(DateHeureCreationFichier(_CIS_TXT));

  messagedlg('Le fichier "CIS.TXT" a t correctement charg' + ^m + ^j + ^m +
    ^j + format('Il comporte %d entre(s)', [ListBox1.Items.Count]) + ^m + ^j +
    ^m + ^j + 'Vous pouvez commencer la recherche ...', mtInformation,
    [mbOK], 0);
  Edit1.SetFocus;

end;

procedure TForm_CIS.mnu_DOWNLOADClick(Sender: TObject);
begin
  shellURL('http://agence-prd.ansm.sante.fr/php/ecodex/telecharger/lirecis.php');
end;

procedure TForm_CIS.Quitter1Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
